#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

//funcion getipa from
/*POSIX/Linux multithreaded socket test
Copyright (c) 2006-2007 Richard Palethorpe

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE

Website: richiejp.wordpress.com email: richiejp@gmail.com*/


struct sockaddr_in getipa(const char* hostname, int port)
{
  struct sockaddr_in ipa;
  ipa.sin_family = AF_INET;
  ipa.sin_port = htons(port);
  
  struct hostent* localhost = gethostbyname(hostname);
  if(!localhost)
    {
      return ipa;
    }
  
  char* addr = localhost->h_addr_list[0];
  memcpy(&ipa.sin_addr.s_addr, addr, sizeof addr);
  
  return ipa;
}


void* thread1(void *in)
{
  struct protoent* udp;
  int sfd;
  char buffer[125];
  struct sockaddr_in receiveAddress,bindAddress;
  socklen_t receiveAddressLen;
  struct timeval timeout;

  udp = getprotobyname("udp");
  sfd = socket(PF_INET, SOCK_DGRAM, udp->p_proto);
  bindAddress = getipa("localhost", 1025+(int)in);

  bind(sfd,(struct sockaddr*)&bindAddress,sizeof (bindAddress));

  memset(&timeout, 0x0, sizeof(timeout));
  timeout.tv_usec = 1000000;
  /* enable timeout for socket */
  setsockopt(sfd, SOL_SOCKET, SO_RCVTIMEO, &timeout, sizeof(timeout));
  
  while(true)
    {
      recvfrom(sfd, buffer, sizeof(buffer),0, 
               (struct sockaddr*)&bindAddress,&receiveAddressLen);
      printf("Thread=%d errno=%d\n",(int)in,errno);
    }

}

int main(void)
{
  pthread_t t1;
  pthread_t t2;
  pthread_t t3;
  pthread_t t4;
  pthread_create(&t1, NULL, thread1,(void*)1);
  pthread_create(&t2, NULL, thread1,(void*)2);
  pthread_create(&t3, NULL, thread1,(void*)3);
  pthread_create(&t4, NULL, thread1,(void*)4);
  while(1)
    {
      for(int i=0;i<1000000;i++)
        {
          for(int j=0;j<1000;j++);
        }
      printf("entering sleep\n");
      usleep(10000);
      printf("exit sleep\n");
    }
}
